function [error] = Corre_error_control_function(R_len_input,r) %verify the correctness of the approximation
mu = [-7,7,-7].';
mu = mu/norm(mu);
mu_1 = (eye(3)-mu*(mu.'))*([1,0,0].');
mu_1 = mu_1/norm(mu_1);
mu_2 = (eye(3)-mu*(mu.'))*([0,1,0].');
mu_2 = mu_2/norm(mu_2);
mu_2 = mu_2 - mu_2.'*mu_1*mu_1;
mu_2 = mu_2/norm(mu_2);
R = (R_len_input*[1,1,1]/sqrt(3)).';
R_len = norm(R);
R_hat = R/R_len;
dy = 0.025; dz = 0.025;
lam = 0.05;
a = 0;

ny = 0; nz = 10;
my = 0.01; mz = 2;

mz_number = 100;
nz_number = 100;

mz_total = -mz_number:1:mz_number;
nz_total = -nz_number:1:nz_number;

Rela = zeros(mz_number,nz_number);
Rela1 = Rela;
C_save = Rela;
A_save = Rela;

for i = 1:2*mz_number+1
    for j = 1:2*nz_number+1

    mz = mz_total(i);
    nz = nz_total(j);

d_1 = [0,0*dy,0*dz].';
d_2 = [0,mz*dy,nz*dz].';
d_1_len = norm(d_1);
d_2_len = norm(d_2);
if(d_1_len~=0)
d_1_hat = d_1/d_1_len;
else
d_1_hat = d_1*0;
end

if(d_2_len~=0)
d_2_hat = d_2/d_2_len;
else
d_2_hat = d_1*0;
end

A1 = 1+(d_1_len/R_len)^2-2*(d_1_len/R_len)*(R_hat.'*mu*d_1_hat.'*mu+R_hat.'*mu_1*d_1_hat.'*mu_1+R_hat.'*mu_2*d_1_hat.'*mu_2);
A2 = 1+(d_2_len/R_len)^2-2*(d_2_len/R_len)*(R_hat.'*mu*d_2_hat.'*mu+R_hat.'*mu_1*d_2_hat.'*mu_1+R_hat.'*mu_2*d_2_hat.'*mu_2);

C = (R_hat.'*mu_1/sqrt(A1)-R_hat.'*mu_1/sqrt(A2)-d_1_len/R_len*d_1_hat.'*mu_1/sqrt(A1)+d_2_len/R_len*d_2_hat.'*mu_1/sqrt(A2))^2;
C = C+(R_hat.'*mu_2/sqrt(A1)-R_hat.'*mu_2/sqrt(A2)-d_1_len/R_len*d_1_hat.'*mu_2/sqrt(A1)+d_2_len/R_len*d_2_hat.'*mu_2/sqrt(A2))^2;
C = (2*pi/lam)^2*C;

C_save(i,j) = C;
A_save(i,j) = A2;

if(C~=0)
Rela(i,j) = 1/sqrt(A1*A2)*exp(-1i*2*pi/lam*R_len*(sqrt(A1)-sqrt(A2)))*2*(a+1)*2^a*gamma(a+1)*(sqrt(C)*r)^(-a-1)*besselj(a+1,sqrt(C)*r);
else
    Rela(i,j) = 1/sqrt(A1*A2)*exp(-1i*2*pi/lam*R_len*(sqrt(A1)-sqrt(A2)));
end

    end
end

% compare the approximated correlation function with numerical integrals
for i = 1:2*mz_number+1
    disp(i)
    for j = 1:2*nz_number+1

    mz = mz_total(i);
    nz = nz_total(j);

d_1 = [0,0*dy,0*dz].';
d_2 = [0,mz*dy,nz*dz].';
R1 = @(rho,theta) (R.'*mu-d_1.'*mu).^2+(R.'*mu_1+rho.*cos(theta)-d_1.'*mu_1).^2+(R.'*mu_2+rho.*sin(theta)-d_1.'*mu_2).^2;
R2 = @(rho,theta) (R.'*mu-d_2.'*mu).^2+(R.'*mu_1+rho.*cos(theta)-d_2.'*mu_1).^2+(R.'*mu_2+rho.*sin(theta)-d_2.'*mu_2).^2;
f = @(rho,theta) R_len^2./sqrt(R1(rho,theta).*R2(rho,theta)).*exp(-1i*2*pi/lam.*(sqrt(R1(rho,theta))-sqrt(R2(rho,theta))));
f1 = @(rho,theta) f(rho,theta)*(a+1)/pi/r^(2*a+2).*rho.*(r^2-rho.^2).^a;

q = integral2(f1,0,r,0,2*pi);

Rela1(i,j) = q;

    end
end

delta_Rela = Rela-Rela1;
error = sum(sum(abs(delta_Rela).^2))/sum(sum(abs(Rela).^2));

end
