close all
clear all
mu = [-7,7,-7].';
mu = mu/norm(mu);
mu_1 = (eye(3)-mu*(mu.'))*([1,0,0].');
mu_1 = mu_1/norm(mu_1);
mu_2 = (eye(3)-mu*(mu.'))*([0,1,0].');
mu_2 = mu_2/norm(mu_2);
mu_2 = mu_2 - mu_2.'*mu_1*mu_1;
mu_2 = mu_2/norm(mu_2);
r = 5;
R = 10*[-10,10,-10].';
R_len = norm(R);
R_hat = R/R_len;
dy = 0.1; dz = 0.1;
lam = 0.05;
a = 3;

ny = 0; nz = 10;
my = 0; mz = 2;

mz_number = 10;
nz_number = 10;

mz_total = -mz_number:1:mz_number;
nz_total = -nz_number:1:nz_number;

N = (2*mz_number+1)*(2*nz_number+1);

number_plot = 4;

Rela = zeros(N,N,number_plot);
C_save = Rela;
A_save = Rela;

for iter = 1:number_plot

%     if(iter==1)
%         r=5; a=-0.99;
%     elseif(iter==2)
%         r=5; a=-0.5;
%     elseif(iter==3)
%         r=5; a=0;
%     else
%         r=5; a=3;
%     end

    if(iter==1)
        r=5; a=-0.99;
    elseif(iter==2)
        r=5; a=-0.5;
    elseif(iter==3)
        r=5; a=0;
    else
        r=5; a=3;
    end

    mu = mu/norm(mu);
mu_1 = (eye(3)-mu*(mu.'))*([1,0,0].');
mu_1 = mu_1/norm(mu_1);
mu_2 = (eye(3)-mu*(mu.'))*([0,1,0].');
mu_2 = mu_2/norm(mu_2);
mu_2 = mu_2 - mu_2.'*mu_1*mu_1;
mu_2 = mu_2/norm(mu_2);

for i = 1:N
    for j = 1:N

    my = floor((i-1)/(2*nz_number+1))-nz_number;
    mz = mod((i-1),2*nz_number+1)-nz_number;

    ny = floor((j-1)/(2*nz_number+1))-nz_number;
    nz = mod((j-1),2*nz_number+1)-nz_number;

d_1 = [0,my*dy,mz*dz].';
d_2 = [0,ny*dy,nz*dz].';
d_1_len = norm(d_1);
d_2_len = norm(d_2);
if(d_1_len~=0)
d_1_hat = d_1/d_1_len;
else
d_1_hat = d_1*0;
end

if(d_2_len~=0)
d_2_hat = d_2/d_2_len;
else
d_2_hat = d_1*0;
end

A1 = 1+(d_1_len/R_len)^2-2*(d_1_len/R_len)*(R_hat.'*mu*d_1_hat.'*mu+R_hat.'*mu_1*d_1_hat.'*mu_1+R_hat.'*mu_2*d_1_hat.'*mu_2);
A2 = 1+(d_2_len/R_len)^2-2*(d_2_len/R_len)*(R_hat.'*mu*d_2_hat.'*mu+R_hat.'*mu_1*d_2_hat.'*mu_1+R_hat.'*mu_2*d_2_hat.'*mu_2);

C = (R_hat.'*mu_1/sqrt(A1)-R_hat.'*mu_1/sqrt(A2)-d_1_len/R_len*d_1_hat.'*mu_1/sqrt(A1)+d_2_len/R_len*d_2_hat.'*mu_1/sqrt(A2))^2;
C = C+(R_hat.'*mu_2/sqrt(A1)-R_hat.'*mu_2/sqrt(A2)-d_1_len/R_len*d_1_hat.'*mu_2/sqrt(A1)+d_2_len/R_len*d_2_hat.'*mu_2/sqrt(A2))^2;
C = (2*pi/lam)^2*C;

% besselj(a+1,x) -> 1/(gamma(a+2))((x+1)/2)^(a+1)

if(C~=0)
Rela(i,j,iter) = 1/sqrt(A1*A2)*exp(-1i*2*pi/lam*R_len*(sqrt(A1)-sqrt(A2)))*2*(a+1)*2^a*gamma(a+1)*(sqrt(C)*r)^(-a-1)*besselj(a+1,sqrt(C)*r);
else
    Rela(i,j,iter) = 1/sqrt(A1*A2)*exp(-1i*2*pi/lam*R_len*(sqrt(A1)-sqrt(A2)));
end
    end
end

end

for i=1:number_plot
    for iter = 1:N
        for iter1 = 1:iter
            Rela(iter,iter1,i) = Rela(iter1,iter,i)';
        end
    end
end

eigen_t = zeros(N,number_plot);
for i=1:number_plot
eigen_t(:,i) = svd(Rela(:,:,i));
eigen_t(:,i) = eigen_t(:,i)/sum(eigen_t(:,i));
end

figure
bar(eigen_t(1:10,:))
grid on
legend(' a = -0.99',' a = -0.5',' a = 0',' a = 3');
%legend(' r = 1',' r = 2',' r = 4',' r = 8');
xlabel('Number of eigenvalues','Interpreter','latex','FontSize',14);
ylabel('Normalized eigenvalue strength','Interpreter','latex','FontSize',14);