close all
clear all
rng(0);
mz_number = 50;
my_number = 50;
threshold = 0.2;
threhold = 1e-3;
mulength = 40;
mz_total = -mz_number:mz_number;
my_total = -my_number:my_number;
lam = 0.2;
dy = lam/8; dz = dy;
iter_test = 30;
R = zeros(2*my_number+1,2*mz_number+1);
N = (2*mz_number+1)*(2*my_number+1);
for i = 1:35    %35
cdl_model = nrCDLChannel('ChannelFiltering', false);
cdl_model.DelayProfile = "CDL-A";
cdl_model.MaximumDopplerShift = 0;
cdl_model.CarrierFrequency = 3e8/lam;
cdl_model.SampleRate = 10e2;
cdl_model.SampleDensity = Inf;
cdl_model.NumTimeSamples = 1;
cdl_model.TransmitAntennaArray.Size = [1, 1, 1, 1, 1]; % [M N P Mg Ng]
cdl_model.ReceiveAntennaArray.Size = [2*my_number+1, 2*mz_number+1, 1, 1, 1];
cdl_model.ReceiveAntennaArray.ElementSpacing = [dy/lam,dz/lam,1,1];
cdl_model.Seed = randi(2^i);   %2^i
[pathGains, ~] = cdl_model();
h = reshape(sum(pathGains(1, :, :, :), 2), [2*my_number+1, 2*mz_number+1]);
K1_temp = dftmtx(2*my_number+1);
K2_temp = dftmtx(2*mz_number+1);
h_fft = K1_temp*h*K2_temp';
h_fft = abs(h_fft);
R = R+h*h(my_number+1,mz_number+1)';
end
[x,y]=meshgrid(my_total,mz_total);
pcolor(x,y,abs(h_fft));
%displayChannel(cdl_model,'LinkEnd','Rx')
% [x,y]=meshgrid(1:(2*my_number+1),1:(2*mz_number+1));
% pcolor(x,y,abs(R));
figure
DFT_Rela = abs(K1_temp*h*K2_temp');
pcolor(x,y,abs(R));
shading interp; 
xlabel('y axis','Interpreter','latex','FontSize',14);
ylabel('z axis','Interpreter','latex','FontSize',14);
Rela_cdl = R;
save('rela_a','Rela_cdl');