addpath('./codebook/');

rng(0);

mz_number = 40;
my_number = 40;

threshold = 0.2;
threhold = 0;
mulength = 40;

mz_total = -mz_number:mz_number;
my_total = -my_number:my_number;

lam = 0.4;
dy = lam/8; dz = dy;

iter_test = 5;

N = (2*mz_number+1)*(2*my_number+1);
rho_t = -10:5:30;
snr_t = 10.^(rho_t/10);
RSLS_vMF_error_mean = 0*rho_t;
RSLS_all_dir_error_mean = 0*rho_t;
RSLS_near_sta_error_mean = 0*rho_t;
OMP_error_mean_20 = 0*rho_t;
OMP_error_mean_40 = 0*rho_t;
Lserror_mean = 0*rho_t;

if exist(['./codebook/Codebook3d_',num2str(2*my_number+1),'_',num2str(2*mz_number+1),'_',num2str(lam),'_',num2str(dy),'.mat'],'file')==0
generate_UPA_Codebook(2*my_number+1,2*mz_number+1,lam,dy);
else
end
load(['./codebook/Codebook3d_',num2str(2*my_number+1),'_',num2str(2*mz_number+1),'_',num2str(lam),'_',num2str(dy),'.mat']);
[~,codebook_near_num] = size(w);

for iter_rho = 1:length(rho_t)
    rho = snr_t(iter_rho);
for i = 1:iter_test

    disp(i);

cdl_model = nrCDLChannel('ChannelFiltering', false);
cdl_model.DelayProfile = "CDL-D";
cdl_model.MaximumDopplerShift       = 300;
cdl_model.CarrierFrequency          = 3e8/lam;
cdl_model.SampleRate                = 10e2;
cdl_model.SampleDensity             = Inf;
cdl_model.NumTimeSamples            = 1;
cdl_model.TransmitAntennaArray.Size = [1, 1, 1, 1, 1];   % [M N P Mg Ng]
cdl_model.ReceiveAntennaArray.Size  = [2*my_number+1, 2*mz_number+1, 1, 1, 1]; 
cdl_model.ReceiveAntennaArray.ElementSpacing = [dy/lam,dz/lam,1,1];
%cdl_model.Seed                      = randi(1);
[pathGains, ~] = cdl_model();
    h = reshape(sum(pathGains(1, :, :, :), 2), [N, 1]);

h = h/sqrt(sum(abs((h).^2)))*sqrt(N);
noise = (randn([N, 1]) + 1i*randn([N, 1]))/sqrt(2);
y = sqrt(rho)*h+noise;

Rela_vMF = zeros(N,N);
Rela_near_sta = zeros(N,N);
[position,DFT_Rela] = cluster_position(y,0,lam,my_total,mz_total,dy,dz,threshold,3);
[cluster_detec,~] = size(position);
%[position] = sparse_detection(H(:,1),3,lam,mz_total,dz);
if(cluster_detec==0)
    count = 0;
while (cluster_detec==0)
    count = count+1;
    [position,DFT_Rela] = cluster_position(y,0,lam,my_total,mz_total,dy,dz,threshold+0.05*count,3);
    [cluster_detec,~] = size(position);
end
end
%[position,H_filtered] = sparse_detection(y,1,lam,mz_total,dz);
for iter = 1:cluster_detec
    matrix_m = (1:N)'*ones(1,N);
    my = floor((matrix_m-1)/(2*mz_number+1))-my_number;
    mz = mod((matrix_m-1),2*mz_number+1)-mz_number;
    matrix_n = ones(N,1)*(1:N);
    ny = floor((matrix_n-1)/(2*mz_number+1))-my_number;
    nz = mod((matrix_n-1),2*mz_number+1)-mz_number;

    ky = (my_number - position(iter,2))/my_number;
    kz = (position(iter,1) - mz_number)/mz_number;
    kx = sqrt(1-ky^2-kz^2);

    if(ky^2+kz^2<1)
    mu = mulength/2*[kx,ky,kz].';
    Rela_vMF = Rela_vMF+correlation_generator_vMF(my,mz,ny,nz,dy,dz,lam,mu);
    Rela_near_sta = Rela_near_sta+correlation_generator(my,mz,ny,nz,dy,dz,mu*1,lam,10,20,[0.9,0.2,0.2]');
    Rela_near_sta = Rela_near_sta+correlation_generator(my,mz,ny,nz,dy,dz,-mu*1,lam,10,20,[0.9,0.2,0.2]');
    end
end

Rela_vMF = Rela_vMF/sum(sum(abs(Rela_vMF)))*(sum(sum(abs(y*y'))));
Rela_near_sta = Rela_near_sta/sum(sum(abs(Rela_near_sta)))*(sum(sum(abs(y*y'))));

[U_vMF,Lam_vMF] = compact_eigenvalue_decomposition(Rela_vMF,threhold);
[U_near_sta,Lam_near_sta] = compact_eigenvalue_decomposition(Rela_near_sta,threhold);

Rela_all_dir = correlation_generator_all_dir(my,mz,ny,nz,dy,dz,lam);
Rela_all_dir = Rela_all_dir/sum(sum(abs(Rela_all_dir)))*(sum(sum(abs(y*y'))));

[U_all_dir,Lam_all_dir] = compact_eigenvalue_decomposition(Rela_all_dir,threhold);


h_ls = y/sqrt(rho);
Lserror = sum(abs((h-h_ls).^2))/sum(abs((h).^2)); 
Lserror_mean(iter_rho) = Lserror_mean(iter_rho)+Lserror;

h_RSLS_vMF = U_vMF*Lam_vMF/(rho*Lam_vMF+eye(length(Lam_vMF)))*U_vMF'*y*sqrt(rho);
RSLS_vMF_error = sum(abs((h-h_RSLS_vMF).^2))/sum(abs((h).^2)); 
RSLS_vMF_error_mean(iter_rho) = RSLS_vMF_error_mean(iter_rho)+RSLS_vMF_error;

h_RSLS_near_sta = U_near_sta*Lam_near_sta/(rho*Lam_near_sta+eye(length(Lam_near_sta)))*U_near_sta'*y*sqrt(rho);
RSLS_near_sta_error = sum(abs((h-h_RSLS_near_sta).^2))/sum(abs((h).^2)); 
RSLS_near_sta_error_mean(iter_rho) = RSLS_near_sta_error_mean(iter_rho)+RSLS_near_sta_error;

h_RSLS_all_dir = U_all_dir*Lam_all_dir/(rho*Lam_all_dir+eye(length(Lam_all_dir)))*U_all_dir'*y*sqrt(rho);
RSLS_all_dir_error = sum(abs((h-h_RSLS_all_dir).^2))/sum(abs((h).^2)); 
RSLS_all_dir_error_mean(iter_rho) = RSLS_all_dir_error_mean(iter_rho)+RSLS_all_dir_error;

[h_near_ls_sparse,~] = SOMP(y, w, 20, codebook_near_num, 1);
h_OMP = w*h_near_ls_sparse/sqrt(rho);
OMPerror = sum(abs((h-h_OMP).^2))/sum(abs((h).^2)); 
OMP_error_mean_20(iter_rho) = OMP_error_mean_20(iter_rho)+OMPerror;

[h_near_ls_sparse,~] = SOMP(y, w, 40, codebook_near_num, 1);
h_OMP = w*h_near_ls_sparse/sqrt(rho);
OMPerror = sum(abs((h-h_OMP).^2))/sum(abs((h).^2)); 
OMP_error_mean_40(iter_rho) = OMP_error_mean_40(iter_rho)+OMPerror;
end
RSLS_vMF_error_mean(iter_rho) = RSLS_vMF_error_mean(iter_rho)/iter_test;
RSLS_all_dir_error_mean(iter_rho) = RSLS_all_dir_error_mean(iter_rho)/iter_test;
RSLS_near_sta_error_mean(iter_rho) = RSLS_near_sta_error_mean(iter_rho)/iter_test;
OMP_error_mean_20(iter_rho) = OMP_error_mean_20(iter_rho)/iter_test;
OMP_error_mean_40(iter_rho) = OMP_error_mean_40(iter_rho)/iter_test;
Lserror_mean(iter_rho) = Lserror_mean(iter_rho)/iter_test;
end

figure
color = linspecer(5);
semilogy(rho_t,Lserror_mean,'-s','Linewidth',1.5,'markersize',5,'Color',color(1,:));
hold on
semilogy(rho_t,RSLS_all_dir_error_mean,'--^','Linewidth',1.5,'markersize',5,'Color',color(2,:));
hold on
semilogy(rho_t,OMP_error_mean_20,'-^','Linewidth',1.5,'markersize',5,'Color',color(3,:));
hold on
semilogy(rho_t,OMP_error_mean_40,'-^','Linewidth',1.5,'markersize',5,'Color',color(4,:));
% hold on
% semilogy(rho_t,RSLS_vMF_error_mean);
hold on
semilogy(rho_t,RSLS_near_sta_error_mean,'--+','Linewidth',1.5,'markersize',5,'Color',color(5,:));
grid on
xlabel('Signal to noise ratio','Interpreter','latex','FontSize',14);
ylabel('NMSE','Interpreter','latex','FontSize',14);
legend('LS','All dir','OMP-20','OMP-40','Proposed');



