clear all
close all
addpath('./codebook/');
rng(0)
%threshold = 0.2; mulength = 40;
threshold = 0.3; mulength = 30;
mu0 = [7,7,7].';
mu0 = mu0/norm(mu0);
% r = 10;
% R = 10*[-10,10,-10].';
lam = 0.2;
dy = lam/8; dz = dy;
% a = 0;

my_number = 20;
mz_number = 20;

mz_total = -mz_number:mz_number;
my_total = -my_number:my_number;

N = (2*my_number+1)*(2*mz_number+1);
Rela_sta = zeros(N,N);

number_of_cluster = 1;


Rela = zeros(N,N);
[R,a,r,mu] = parameter_random_generator(number_of_cluster);
                
matrix_m = (1:N)'*ones(1,N);
my = floor((matrix_m-1)/(2*mz_number+1))-my_number;
mz = mod((matrix_m-1),2*mz_number+1)-mz_number;
matrix_n = ones(N,1)*(1:N);
ny = floor((matrix_n-1)/(2*mz_number+1))-my_number;
nz = mod((matrix_n-1),2*mz_number+1)-mz_number;
                    
for iter = 1:number_of_cluster
     Rela = Rela+(rand+1)*correlation_generator(my,mz,ny,nz,dy,dz,R(:,iter),lam,a(1,iter),r(1,iter),mu(:,iter));
end

Rela_all_dir = correlation_generator_all_dir(my,mz,ny,nz,dy,dz,lam);

iter_test = 50;
different_par = 50;

trace_Rela = trace(Rela);

trace_Rela_all_dir = trace(Rela_all_dir);


Rela_all_dir = Rela_all_dir*trace_Rela/trace_Rela_all_dir;

threhold = 1e-3;

[U_all_dir,Lam_all_dir] = compact_eigenvalue_decomposition(Rela_all_dir,threhold);

rho_t = -10:5:30;
snr_t = 10.^(rho_t/10);
Lserror_mean = 0*rho_t;
RSLS_all_dir_error_mean = 0*rho_t;
Proposed_error_mean = 0*rho_t;
OMP_4_mean = 0*rho_t;
OMP_10_mean = 0*rho_t;
OMP_20_mean = 0*rho_t;

if exist(['./codebook/Codebook3d_',num2str(2*my_number+1),'_',num2str(2*mz_number+1),'_',num2str(lam),'_',num2str(dy),'.mat'],'file')==0
generate_UPA_Codebook(2*my_number+1,2*mz_number+1,lam,dy);
else
end
load(['./codebook/Codebook3d_',num2str(2*my_number+1),'_',num2str(2*mz_number+1),'_',num2str(lam),'_',num2str(dy),'.mat']);
[~,codebook_near_num] = size(w);

for iter_rho = 1:length(rho_t)
    rho = snr_t(iter_rho);

    for iter_par = 1:different_par
        
        Rela = zeros(N,N);
        [R,a,r,mu] = parameter_random_generator(number_of_cluster);
        
            matrix_m = (1:N)'*ones(1,N);
            my = floor((matrix_m-1)/(2*mz_number+1))-my_number;
            mz = mod((matrix_m-1),2*mz_number+1)-mz_number;
            matrix_n = ones(N,1)*(1:N);
            ny = floor((matrix_n-1)/(2*mz_number+1))-my_number;
            nz = mod((matrix_n-1),2*mz_number+1)-mz_number;
            
            for iter = 1:number_of_cluster
                Rela = Rela+(rand+1)*correlation_generator(my,mz,ny,nz,dy,dz,R(:,iter),lam,a(1,iter),r(1,iter),mu(:,iter));
            end
            
            Rela_all_dir = correlation_generator_all_dir(my,mz,ny,nz,dy,dz,lam);
            trace_Rela = trace(Rela);
            Rela_all_dir = Rela_all_dir*trace_Rela/trace_Rela_all_dir;

threhold = 1e-3;

[U_all_dir,Lam_all_dir] = compact_eigenvalue_decomposition(Rela_all_dir,threhold);

        [H,L,error,Rela1] = channel_generator(Rela,10);

        disp(iter_par)
    
        [U,Lam] = compact_eigenvalue_decomposition(Rela,threhold);
    Rela_Proposed = zeros(N,N);
    Rela_far = zeros(N,N);
    y = H(:,1)*0;
    for iter_channel = 1:1
    h = H(:,iter_channel);
    h = h/sqrt(sum(abs((h).^2)))*sqrt(N);
    noise = (randn([N, 1]) + 1i*randn([N, 1]))/sqrt(2);
    y = y+sqrt(rho)*h+noise;
    end
    
    [position] = cluster_position(y,0,lam,my_total,mz_total,dy,dz,threshold,3);
    [cluster_detec,~] = size(position);
    %[position] = sparse_detection(H(:,1),3,lam,mz_total,dz);
    if(cluster_detec==0)
        count = 0;
    while (cluster_detec==0)
        count = count+1;
        [position] = cluster_position(y,10,lam,my_total,mz_total,dy,dz,threshold+0.05*count,3);
        [cluster_detec,~] = size(position);
    end
    end
    for iter = 1:cluster_detec
        matrix_m = (1:N)'*ones(1,N);
        my = floor((matrix_m-1)/(2*mz_number+1))-my_number;
        mz = mod((matrix_m-1),2*mz_number+1)-mz_number;
        matrix_n = ones(N,1)*(1:N);
        ny = floor((matrix_n-1)/(2*mz_number+1))-my_number;
        nz = mod((matrix_n-1),2*mz_number+1)-mz_number;

        ky = -(my_number+1 - position(iter,1))/my_number;
        kz = -(position(iter,2) - mz_number-1)/mz_number;
        kx = sqrt(1-ky^2-kz^2);

        if(ky^2+kz^2<1)
        mu = mulength*[kx,ky,kz].';
        mu1 = mulength*[-kx,ky,kz].';
        Rela_Proposed = Rela_Proposed+correlation_generator(my,mz,ny,nz,dy,dz,mu,lam,0,3,[1/sqrt(3),1/sqrt(3),1/sqrt(3)]');
        Rela_Proposed = Rela_Proposed+correlation_generator(my,mz,ny,nz,dy,dz,mu1,lam,0,3,[1/sqrt(3),1/sqrt(3),1/sqrt(3)]');
        end
   end

    trace_Rela_Proposed = trace(Rela_Proposed);
    Rela_Proposed = Rela_Proposed*trace_Rela/trace_Rela_Proposed;
    
    [U_Proposed,Lam_Proposed] = compact_eigenvalue_decomposition(Rela_Proposed,threhold);
    
for i = 1:iter_test/different_par

    h = H(:,i);
    h1 = reshape(h,2*mz_number+1,[]);
    h = h/sqrt(sum(abs((h).^2)))*sqrt(N);
    noise = (randn([N, 1]) + 1i*randn([N, 1]))/sqrt(2);
    y = sqrt(rho)*h+noise;

    
    h1 = h1.';
    h1 = reshape(h1,1,[]).';
    h1 = h1/sqrt(sum(abs((h1).^2)))*sqrt(N);
    y1 = sqrt(rho)*h1+noise;

    h_ls = y/sqrt(rho);
    Lserror = sum(abs((h-h_ls).^2))/sum(abs((h).^2)); 
    Lserror_mean(iter_rho) = Lserror_mean(iter_rho)+Lserror;

    h_RSLS_all_dir = U_all_dir*Lam_all_dir/(rho*Lam_all_dir+eye(length(Lam_all_dir)))*U_all_dir'*y*sqrt(rho);
    RSLS_all_dir_error = sum(abs((h-h_RSLS_all_dir).^2))/sum(abs((h).^2)); 
    RSLS_all_dir_error_mean(iter_rho) = RSLS_all_dir_error_mean(iter_rho)+RSLS_all_dir_error;
    
    h_Proposed = U_Proposed*Lam_Proposed/(rho*Lam_Proposed+eye(length(Lam_Proposed)))*U_Proposed'*y*sqrt(rho);
    Proposed_error = sum(abs((h-h_Proposed).^2))/sum(abs((h).^2)); 
    Proposed_error_mean(iter_rho) = Proposed_error_mean(iter_rho)+Proposed_error;

    [h_near_ls_sparse,~] = SOMP(y1, w, 4, codebook_near_num, 1);
    h_ls_sparse = w*h_near_ls_sparse/sqrt(rho);
    OMP_4 = sum(abs((h1-h_ls_sparse).^2))/sum(abs((h1).^2)); 
    OMP_4_mean(iter_rho) = OMP_4_mean(iter_rho)+OMP_4;

    [h_near_ls_sparse,support] = SOMP(y1, w, 10, codebook_near_num, 1);
    h_near_ls_sparse = w*h_near_ls_sparse/sqrt(rho);
    OMP_10 = sum(abs((h1-h_near_ls_sparse).^2))/sum(abs((h1).^2)); 
    OMP_10_mean(iter_rho) = OMP_10_mean(iter_rho)+OMP_10;

    [h_near_ls_sparse,~] = SOMP(y1, w, 20, codebook_near_num, 1);
    h_mmse = w*h_near_ls_sparse/sqrt(rho);
    OMP_20 = sum(abs((h1-h_mmse).^2))/sum(abs((h1).^2)); 
    OMP_20_mean(iter_rho) = OMP_20_mean(iter_rho)+OMP_20;

end
    end
Lserror_mean(iter_rho) = Lserror_mean(iter_rho)/iter_test;
RSLS_all_dir_error_mean(iter_rho) = RSLS_all_dir_error_mean(iter_rho)/iter_test;
Proposed_error_mean(iter_rho) = Proposed_error_mean(iter_rho)/iter_test;
OMP_4_mean(iter_rho) = OMP_4_mean(iter_rho)/iter_test;
OMP_10_mean(iter_rho) = OMP_10_mean(iter_rho)/iter_test;
OMP_20_mean(iter_rho) = OMP_20_mean(iter_rho)/iter_test;
end
color = linspecer(6);
figure
semilogy(rho_t,Lserror_mean,'-s','Linewidth',1.5,'markersize',5,'Color',color(1,:));
hold on 
semilogy(rho_t,OMP_4_mean,'-^','Linewidth',1.5,'markersize',5,'Color',color(2,:));
hold on 
semilogy(rho_t,OMP_10_mean,'-^','Linewidth',1.5,'markersize',5,'Color',color(3,:));
hold on 
semilogy(rho_t,OMP_20_mean,'-^','Linewidth',1.5,'markersize',5,'Color',color(4,:));
hold on
semilogy(rho_t,RSLS_all_dir_error_mean,'--^','Linewidth',1.5,'markersize',5,'Color',color(5,:));
hold on
semilogy(rho_t,Proposed_error_mean,'--+','Linewidth',1.5,'markersize',5,'Color',color(6,:));
grid on
xlabel('Signal to noise ratio','Interpreter','latex','FontSize',14);
ylabel('NMSE','Interpreter','latex','FontSize',14);
legend('LS','OMP-4','OMP-10','OMP-20','Subspace','Proposed');