function [Rela] = correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu)
mu = mu/norm(mu);
mu_1 = (eye(3)-mu*(mu.'))*([1,0,0].');
mu_1 = mu_1/norm(mu_1);
mu_2 = (eye(3)-mu*(mu.'))*([0,1,0].');
mu_2 = mu_2/norm(mu_2);
mu_2 = mu_2 - mu_2.'*mu_1*mu_1;
mu_2 = mu_2/norm(mu_2);

R_len = norm(R);
R_hat = R/R_len;

d_1y = my*dy; d_1z = mz*dz; d_1x = 0*my;
d_2y = ny*dy; d_2z = nz*dz; d_2x = 0*ny;
d_1_len = sqrt(d_1y.^2+d_1z.^2);
d_2_len = sqrt(d_2y.^2+d_2z.^2);
d_1y_hat = d_1y./d_1_len; d_1y_hat(isinf(d_1y_hat))=0;d_1y_hat(isnan(d_1y_hat))=0;
d_1z_hat = d_1z./d_1_len; d_1z_hat(isinf(d_1z_hat))=0;d_1z_hat(isnan(d_1z_hat))=0;
d_2y_hat = d_2y./d_2_len; d_2y_hat(isinf(d_2y_hat))=0;d_2y_hat(isnan(d_2y_hat))=0;
d_2z_hat = d_2z./d_2_len; d_2z_hat(isinf(d_2z_hat))=0;d_2z_hat(isnan(d_2z_hat))=0;
d_1_hat_mu = d_1y_hat*mu(2)+d_1z_hat*mu(3);
d_1_hat_mu1 = d_1y_hat*mu_1(2)+d_1z_hat*mu_1(3);
d_1_hat_mu2 = d_1y_hat*mu_2(2)+d_1z_hat*mu_2(3);
d_2_hat_mu = d_2y_hat*mu(2)+d_2z_hat*mu(3);
d_2_hat_mu1 = d_2y_hat*mu_1(2)+d_2z_hat*mu_1(3);
d_2_hat_mu2 = d_2y_hat*mu_2(2)+d_2z_hat*mu_2(3);


A1 = 1+(d_1_len/R_len).^2-2*(d_1_len/R_len).*(R_hat.'*mu.*d_1_hat_mu+R_hat.'*mu_1.*d_1_hat_mu1+R_hat.'*mu_2.*d_1_hat_mu2);
A2 = 1+(d_2_len/R_len).^2-2*(d_2_len/R_len).*(R_hat.'*mu.*d_2_hat_mu+R_hat.'*mu_1.*d_2_hat_mu1+R_hat.'*mu_2.*d_2_hat_mu2);

C = (R_hat.'*mu_1./sqrt(A1)-R_hat.'*mu_1./sqrt(A2)-d_1_len/R_len.*d_1_hat_mu1./sqrt(A1)+d_2_len/R_len.*d_2_hat_mu1./sqrt(A2)).^2;
C = C+(R_hat.'*mu_2./sqrt(A1)-R_hat.'*mu_2./sqrt(A2)-d_1_len/R_len.*d_1_hat_mu2./sqrt(A1)+d_2_len/R_len.*d_2_hat_mu2./sqrt(A2)).^2;
C = (2*pi/lam)^2*C;

% besselj(a+1,x) -> 1/(gamma(a+2))((x+1)/2)^(a+1)

cover_matrix = (C==0);

Rela = 1./sqrt(A1.*A2).*exp(-1i*2*pi/lam*R_len.*(sqrt(A1)-sqrt(A2)))*2*(a+1)*2^a*gamma(a+1).*(sqrt(C)*r).^(-a-1).*besselj(a+1,sqrt(C)*r);
Rela(cover_matrix)=0;
Rela1 = 1./sqrt(A1.*A2).*exp(-1i*2*pi/lam*R_len.*(sqrt(A1)-sqrt(A2)));
Rela = Rela+cover_matrix.*Rela1;

end

