clear
close all
R_len = 25:25:250;
r = 0.5:0.5:8;
if exist('error_save.mat','file')==0
    error = zeros(length(R_len),length(r));
    for i = 1:length(R_len)
        for j = 1:length(r)
            error(i,j)=Corre_error_control_function(R_len(i),r(j));
        end
    end
else
    load('error_save.mat')
end

figure
[R_len_mesh,r_mesh] = meshgrid(R_len,r);
H1=mesh(R_len_mesh,r_mesh,error');
hold on
[x,y,z] = threshold_line(R_len,r,error,0.1);
plot3(x,y,z,'Linewidth',1.5,'color',[1,0.4,0]);
hold on
[x,y,z] = threshold_line(R_len,r,error,0.01);
plot3(x,y,z,'Linewidth',1.5,'color','red');
hold on
[x,y,z] = threshold_line(R_len,r,error,1e-3);
plot3(x,y,z,'Linewidth',1.5,'color','m');

xlabel('Distance between the array and the scatterer','Interpreter','latex','FontSize',12,'Rotation',-15);
ylabel('Radius of the scatterer','Interpreter','latex','FontSize',12,'Rotation',30);
zlabel('Relative approximation error','Interpreter','latex','FontSize',12)

% 
% figure
% contour(R_len,r,error','ShowText','on');
% grid on

% figure
% plot(R_len,error(:,1));
% hold on
% plot(R_len,error(:,2));
% hold on
% plot(R_len,error(:,3));
% xlabel('Distance between the array and the scatterer','Interpreter','latex','FontSize',12);
% ylabel('Relative approximation error','Interpreter','latex','FontSize',12);


function [x,y,z] = threshold_line(R_len,r,error,threshold)
x = [];y = [];z = [];
for i = 1:length(R_len)
    for j = 1:length(r)-1
        if (error(i,j)<=threshold&&error(i,j+1)>=threshold)
            x = [x,R_len(i)];
            y  = [y,r(j+1) - (error(i,j+1)-threshold)*(r(2)-r(1))/(error(i,j+1)-error(i,j))];
            z = [z,threshold+5e-3];
        end
    end
    if(i~= length(R_len))
    for j = 1:length(r)
        if (error(i,j)>=threshold&&error(i+1,j)<=threshold)
            x = [x,R_len(i+1) - (error(i+1,j)-threshold)*(R_len(2)-R_len(1))/(error(i+1,j)-error(i,j))];
            y  = [y,r(j)];
            z = [z,threshold+5e-3];
        end
    end
    end
end
end




