close all
clear all
load('rela_ray_tracing.mat');
global Rela_cdl_d;
global lam;
global dy; global dz;
global my_number;
global mz_number;
global save_fval;
global my_total;
global mz_total;
save_fval = [];
lam = 0.2;
dy = lam/8; dz = dy;
my_number = 50;
mz_number = 0;
Rela_cdl_d = Rela_cdl(my_number+1,:);
my_total = 0:1:2*my_number;
mz_total = -mz_number:1:mz_number;
Rela = zeros(2*mz_number+1,2*my_number+1);
my = 0*Rela; mz = 0*Rela; 
ny = ones(2*mz_number+1,1)*my_total;
nz = mz_total'*ones(1,2*my_number+1);
options = optimoptions(@fminunc,'Display','iter','Algorithm','quasi-newton','OutputFcn',@outfun);
%x0 = [0.5,1,0,-1,1,1,-7,7,-7;0.1,1,0,1,-0.8,4,-7,7,-7;0,10,0,5,-0.8,4,7,7,-7];   
%x0 = [1,30,0,-5,1,1,-7,7,-7;1,30,0,5,-0.8,4,-7,7,-7;0,10,0,5,-0.8,4,7,7,-7];
%x0 = [0.01,60,40,-8,-0.8,10,-7,-7,-7;0.01,5,-10,40,-0.8,10,-7,-7,-7;0.01,10,0,5,-0.8,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
x0 = [0.1,60,40,-8,-0.8,10,-7,-7,-7;0.01,10,-5,40,-0.8,10,-7,-7,-7;0.1,10,0,4.5,-0.8,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
%x0 = [0.01,60,40,-8,0,10,-7,-7,-7;0.01,5,-10,40,0,10,-7,-7,-7;0.01,10,0,5,0,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
%x0 = [0.01,60,40,-8,-0.8,10,-7,-7,-7;0.01,10,-5,40,-0.8,10,-7,-7,-7;0.01,10,-5,50,-0.8,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
%x0 = [0.1,6,4,-8,-0.8,10,-7,-7,-7;0.01,10,-5,40,-0.8,10,-7,-7,-7;0.01,10,-5,5,-0.8,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
[x_out,fval,exitflag,output] = fminunc(@myfun,x0,options)
global Rela_temp1 
Rela = myfun_rela(x_out);
Rela_temp1 = Rela;
x0 = [0.1,6,4,-8,-0.8,10,-7,-7,-7;0.1,5,-10,4,-0.8,10,-7,-7,-7;0.1,1,0,5,-0.8,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
[x_out1,fval,exitflag,output] = fminunc(@myfun1,x0,options)
Rela1 = myfun_rela(x_out1);
Rela_total = Rela+Rela1;
Rela = Rela_total;

figure
color = linspecer(2);
plot(0:1/8:2*50/8,abs(Rela_cdl_d*1000),'-s','Linewidth',1.5,'markersize',5,'Color',color(1,:));
hold on
plot(0:1/8:2*50/8,abs(Rela),'-^','Linewidth',1.5,'markersize',5,'Color',color(2,:));
grid on
xlabel('Distance from the origin/$\lambda$','Interpreter','latex','FontSize',14);
ylabel('Correlation strength','Interpreter','latex','FontSize',14);
legend('Ray tracing','Proposed model');

function [Rela] = myfun_rela(param)
global Rela_cdl_d;
global lam;
global dy; global dz;
global my_number;
global mz_number;
global my_total;
global mz_total;
% my_total = -my_number:1:my_number;
% mz_total = -mz_number:1:mz_number;
Rela = zeros(2*mz_number+1,2*my_number+1);
%Rela = ones(2*mz_number+1,2*my_number+1)*sum(sum(abs(Rela_cdl_d*1000)))/(2*my_number+1)/(2*mz_number+1);
my = 0*Rela; mz = 0*Rela; 
ny = ones(2*mz_number+1,1)*my_total;
nz = mz_total'*ones(1,2*my_number+1);
    Rela = Rela+param(1,1)*correlation_generator(my,mz,ny,nz,dy,dz,param(1,2:4)',lam,param(1,5),param(1,6),param(1,7:9)');
Rela = Rela+param(2,1)*correlation_generator(my,mz,ny,nz,dy,dz,param(2,2:4)',lam,param(2,5),param(2,6),param(2,7:9)');
Rela = Rela+param(3,1)*correlation_generator(my,mz,ny,nz,dy,dz,param(3,2:4)',lam,param(3,5),param(3,6),param(3,7:9)');
end

function stop = outfun(x, optimValues, state)
stop = false;
global save_fval;
i=optimValues.iteration;
save_fval = [save_fval,optimValues.fval];
drawnow
end