function [position,H_filtered] = sparse_detection(H,n,lam,mz_total,dz)
    [N,~] = size(H);
    H_filtered = 0*H;
    l = sqrt(N);
    H_reshape = zeros(l,l);
    for i = 1:l
        H_reshape(i,:) = H((i-1)*l+1:i*l);
    end
    K1_temp = DFTmatrix(lam,mz_total,dz);
    K2_temp = DFTmatrix(lam,mz_total,dz);
    DFT_Rela_save = K1_temp*H_reshape*K2_temp';
    DFT_Rela = abs(DFT_Rela_save);
    DFT_Rela_filtered = DFT_Rela*0;
    DFT_Rela_reshape = zeros(N,1);
    for i = 1:l
        DFT_Rela_reshape((i-1)*l+1:i*l) = DFT_Rela(i,:);
    end
    [b,~] = sort(DFT_Rela_reshape,'descend');
    position = zeros(n,2);
    for i = 1:n
         [i1,i2]= find(b(i)==DFT_Rela);
         position(i,:) = [i1,i2];
         DFT_Rela_filtered(i1,i2) = b(i);
    end
    H_reshape_filtered = K1_temp'*DFT_Rela_filtered*K2_temp/N;
    for i = 1:l
     H_filtered((i-1)*l+1:i*l) = H_reshape_filtered(i,:);
    end
end